/* (c) Copyright Sony Ericsson Mobile Communications AB. 2010 All rights reserved. */

// Global variables
var SEARCHANY = 1;
var SEARCHALL = 2;
var SEARCHURL = 4;
var searchType = '';
var showMatches = 10; // This variables sets the number of records to display for each results page
var currentMatch = 0;
var copyArray = new Array();

// Use this function to read any cookie when loading the search page
function readCookie() {
  var cookie = document.cookie;
  var cookiepairs = cookie.split("; ");
  for (i = 0; i < cookiepairs.length; i++) {
    if (cookiepairs[i].split("=")[0] == "reference") {
      currentMatch = cookiepairs[i].split("=")[1];
    }
  }
  for (i = 0; i < cookiepairs.length; i++) {
    if (cookiepairs[i].split("=")[0] == "entry") {
      var entryvalue = unescape(cookiepairs[i].split("=")[1]);
      document.forms[0].query.value = entryvalue;
      validate(entryvalue, currentMatch);
    }
  }
}

// This function determines the type of search, makes sure something is entered, and makes sure it is entered correctly
function validate(entry, ref) {
  var pipe = new RegExp("\\u007c");
  if (entry.search(pipe) != -1) {
    alert("Ihre Suche darf kein Verkettungszeichen (|) enthalten.");
    document.forms[0].query.focus();
    return;
  }
  if (entry.length < 3) {
    alert("Die gesuchte Zeichenfolge muss aus mindestens drei Zeichen bestehen.");
    document.forms[0].query.focus();
    return;
  }
  if (entry.charAt(0) == "+") {
    entry = entry.substring(1,entry.length);
    searchType = SEARCHALL;
  }
  else if (entry.substring(0,4) == "url:") {
    entry = entry.substring(4,entry.length);
    searchType = SEARCHURL;
  }
  else if (entry.charAt(0) == '"' && entry.charAt(entry.length - 1) == '"') {
    searchType = SEARCHALL;
  }
  else {
    searchType = SEARCHANY;
  }
  while (entry.charAt(0) == ' ') {
    entry = entry.substring(1,entry.length);
    document.forms[0].query.value = entry;
  }
  while (entry.charAt(entry.length - 1) == ' ') {
    entry = entry.substring(0,entry.length - 1);
    document.forms[0].query.value = entry;
  }
  var whitespace = new RegExp(/(\s)/);
  /* After having removed white space in beginning and end, check if the entry still has white space.
     If so, more than one word has been entered, and the search should be done on all words. */
  if (entry.search(whitespace) != -1) {
    searchType = SEARCHALL;
  }
  document.cookie = "entry=" + escape(entry) + "; path=/";
  document.cookie = "reference=" + ref + "; path=/";
  convertString(entry);
}

// Put the search terms in an array and call the appropriate search function
function convertString(reentry) {
  if (reentry.charAt(0) == '"' && reentry.charAt(reentry.length - 1) == '"') {
    var searchArray = new Array(reentry.substring(1,reentry.length - 1));
  }
  else {
    var searchArray = reentry.split(" ");
  }
  if (searchType == SEARCHALL) {
    requireAll(searchArray, reentry);
  }
  else {
    allowAny(searchArray, reentry);
  }
}

// Function to perform a search that requires a match of any of the terms provided
function allowAny(t, reentry) {
  var findings = new Array(0);
  for (i = 0; i < records.length; i++) {
    var compareElement = records[i].toLowerCase();
    var divide = compareElement.split("|");
    if (searchType == SEARCHANY) {
      // Search title and content
      var refineElement = divide[0] + divide[1];
    }
    else {
      // Search HTTP address only
      var refineElement = divide[2];
    }
    for (j = 0; j < t.length; j++) {
      var compareString = t[j].toLowerCase();
      if (refineElement.indexOf(compareString) != -1) {
        findings[findings.length] = records[i];
        break;
      }
    }
  }
  verifyManage(findings, reentry);
}

// Function to perform a search that requires a match of all terms provided
function requireAll(t, reentry) {
  var findings = new Array();
  for (i = 0; i < records.length; i++) {
    var allConfirmation = true;
    var allString = records[i].toLowerCase();
    var divide = allString.split("|");
    var refineAllString = divide[0] + divide[1];
    for (j = 0; j < t.length; j++) {
      var allElement = t[j].toLowerCase();
      if (refineAllString.indexOf(allElement) == -1) {
        allConfirmation = false;
        continue;
      }
    }
    if (allConfirmation) {
      findings[findings.length] = records[i];
    }
  }
  verifyManage(findings, reentry);
}

// Function to determine whether the search was successful. If so print the results; if not, indicate that
function verifyManage(resultSet, reentry) {
  if (resultSet.length == 0) {
    noMatch(reentry);
  }
  else {
    copyArray = resultSet.sort();
    var cookie = document.cookie;
    var cookiepairs = cookie.split("; ");
    for (i = 0; i < cookiepairs.length; i++) {
      cookievalue = cookiepairs[i].split("=");
      if (cookievalue[0] == "reference") {
        currentMatch = ((cookievalue[1])/10)*showMatches;
      }
    }
    formatResults(copyArray, currentMatch, showMatches, reentry);
  }
}

// Function that indicates that the search returned no results
function noMatch(reentry) {
  var elem, txt;
  elem = document.createElement("p");
  txt = document.createTextNode("Keine Ergebnisse gefunden.");
  elem.appendChild(txt);

  var count = 0;
  for (var i = 0; i < document.body.childNodes.length; i++) {
    count++;
    if (document.body.childNodes[i].nodeName.toLowerCase() == 'form') {
      break;
    }
  }

  while (document.body.childNodes.length > count) {
    document.body.removeChild(document.body.lastChild);
  }
  document.body.appendChild(elem);
}

// Function to print the results of a successful search
function formatResults(results, reference, offset, reentry) {
  var elem, anchor, txt, currentRecord, divide, br;
  currentRecord = (results.length < reference + offset ? results.length : reference + offset);
  elem = document.createElement("p");
  txt = document.createTextNode("Ergebnis " + (reference + 1) + " - " + currentRecord + " von " + results.length);
  elem.appendChild(txt);

  var count = 0;
  for (var i = 0; i < document.body.childNodes.length; i++) {
    count++;
    if (document.body.childNodes[i].nodeName.toLowerCase() == 'form') {
      break;
    }
  }

  while (document.body.childNodes.length > count) {
    document.body.removeChild(document.body.lastChild);
  }
  document.body.appendChild(elem);

  if (searchType == SEARCHURL) {
    for (var i = reference; i < currentRecord; i++) {
      divide = results[i].split("|");
      elem = document.createElement("p");
      anchor = document.createElement("a");
      anchor.setAttribute("href", divide[2]);
      txt = document.createTextNode(divide[2]);
      anchor.appendChild(txt);
      elem.appendChild(anchor);
      br = document.createElement("br");
      elem.appendChild(br);
      txt = document.createTextNode(divide[1].substring(0, 100) + " ...");
      elem.appendChild(txt);
      document.body.appendChild(elem);
    }
  }
  else {
    for (var i = reference; i < currentRecord; i++) {
      divide = results[i].split("|");
      elem = document.createElement("p");
      anchor = document.createElement("a");
      anchor.setAttribute("href", divide[2]);
      txt = document.createTextNode(divide[0]);
      anchor.appendChild(txt);
      elem.appendChild(anchor);
      br = document.createElement("br");
      elem.appendChild(br);
      txt = document.createTextNode(divide[1].substring(0, 100) + " ...");
      elem.appendChild(txt);
      document.body.appendChild(elem);
    }
  }
  document.cookie = "reference=" + reference + "; path=/";
  resultLinks(results.length, reference, offset, reentry);
}

// Function to dynamically display results links
function resultLinks(ceiling, reference, offset, reentry) {
  var anchor, numberoflinks, elem, current;
  numberoflinks = Math.ceil(ceiling/offset);

  if (ceiling > offset) {
    elem = document.createElement("div");
    elem.setAttribute("class", "result");
    elem.setAttribute("className", "result");
    for (var i = 1; i <= numberoflinks; i++) {
      anchor = document.createElement("a");
      anchor.setAttribute("class", "result");
      anchor.setAttribute("className", "result");
      anchor.setAttribute("id", i);
      anchor.setAttribute("href", "#");
      function link(e) {
        var e = e ? e : window.event;
        var element = e.target ? e.target : e.srcElement;
        formatResults(copyArray, (element.id - 1)*offset, offset, reentry);
        window.scrollTo(0,0);
        return false;
      }
      // Detection for Firefox
      if (anchor.addEventListener) {
        anchor.addEventListener('click', link, false);
      }
      // Detection for Internet Explorer
      else if (anchor.attachEvent) {
        anchor.attachEvent('onclick', link);
      }
      txt = document.createTextNode(i);
      anchor.appendChild(txt);
      if (reference / offset + 1 == i) {
        current = document.createElement("span");
        current.setAttribute("class", "current");
        current.setAttribute("className", "current");
        current.appendChild(txt);
        elem.appendChild(current);
      }
      else {
        elem.appendChild(anchor);
      }
    }
    document.body.appendChild(elem);
  }
}